//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//file orientation.cpp
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include "orientation.h"
#include <iostream.h>
#include <iomanip.h>

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori::Ori(char sz,char ord):size(sz), order(ord)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	data = new char[sz];
	for (char i=0;i<sz;i++) data[i]=0;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori::Ori(char sz,char ord,int index):size(sz), order(ord)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	data = new char[sz];
	int orderSum=0;
	for (char i=0;i<sz-1;i++)
	{	orderSum += data[sz-2-i]= (char)(index%ord);
		index /= ord;
	}
	data[sz-1]=(char)((ord-(orderSum%ord))%ord);//sum is 0 mod ord
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori::Ori(char sz,char ord,char* dat):size(sz), order(ord)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	data = new char[sz];
	for (int i=0;i<sz;i++)
		data[i]=dat[i];
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori::Ori(const Ori& o):size(o.size),order(o.order)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	data = new char[size];
	for (char i=0;i<size;i++) data[i]=o.data[i];
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori& Ori::operator=(const Ori& o)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 {	if (size==o.size &&order==o.order)//does not make any sense else
	for (char i=0;i<size;i++)
		data[i]=o.data[i];
	return *this;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori::~Ori()
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	delete[] data;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int Ori::Index()
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	int s = data[0];
	for (int i=1;i<size-1;i++)	//no choice for last element
	{	s *=order;	s+= data[i];}
	return s;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void Ori::Print()
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	for (int i=0;i<size;i++) cout<<setw(3)<<(int)data[i]<<" ";
	cout<<endl;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
COri::COri():Ori(N_CORNER,N_TWIST)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
COri::COri(int index):Ori(N_CORNER,N_TWIST,index)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
COri::COri(char *dat):Ori(N_CORNER,N_TWIST,dat)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori& COri::operator=(const Ori& o)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	return Ori::operator=(o);
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
EOri::EOri():Ori(N_EDGE,N_FLIP)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
EOri::EOri(int index):Ori(N_EDGE,N_FLIP,index)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
EOri::EOri(char *dat):Ori(N_EDGE,N_FLIP,dat)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Ori& EOri::operator=(const Ori& o)
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	return Ori::operator=(o);
}
