//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//file orientation.h
//
//class Ori is a helper class which is needed to "attach" the flips and twists
//of the edges and corners to the permutations (wreath product)
//char size:  the number of elements
//char order: number of possible orientations (2 for edges, 3 for corners)
//int Index(): maps each object onto a unique number from 0 to order^size-1
//
//the classes COri and EOri define objects of size 8 and 12 and order 3 and 2
//which are uses for the corner- and edge-orientations.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

#ifndef ORIENTATION_H
#define ORIENTATION_H

#include "constants.h"

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class Ori
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{public:
	Ori(char size,char order);
	Ori(char size,char order, int index);
	Ori(char size,char order, char* dat);
	Ori(const Ori& o);
	Ori& operator=(const Ori&);
  	~Ori();
	int Index();
	void Print();
	char* data;

	const char size;
	const char order;
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class COri:public Ori
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{public:
	COri();
	COri(int index);
	COri(char* dat);
	Ori& operator=(const Ori&);
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class EOri:public Ori
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{public:
	EOri();
	EOri(int index);
	EOri(char* dat);
	Ori& operator=(const Ori&);
};

#endif