//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//file permutation.h
//
//an object of class Perm represents a permutation.
//char size:   the number of elements of the permutation
//int Index(): maps each permutation onto a unique number from 0 to size!-1
//operator *:  defines the multiplication of two permutations
//
//the classes CPerm and EPerm define permutations of size 8 and 12
//these are uses for the corner- and edge permutations of the cube
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


#ifndef PERMUTATION_H
#define PERMUTATION_H

#include "constants.h"

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class Perm
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{public:
	Perm(char size);
	Perm(char size, int index);
	Perm(char size,char* dat);
	Perm(const Perm&);
	~Perm();
	Perm& operator=(const Perm&);
	Perm Inverse();
	bool Even();
	Perm operator*(const Perm& p);
	void Print();
	int Index();

	char* data;
	const char size;
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class CPerm: public Perm
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	public:
	CPerm();
	CPerm(int index);
	CPerm(char* dat);
	Perm& operator=(const Perm&);
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class EPerm: public Perm
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{	public:

	EPerm();
	EPerm(int index);
	EPerm(char* dat);
	Perm& operator=(const Perm&);
};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int Cnk(char n,char k);	//n!/k!/(n-k)!
int Fak(char n);//n!
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#endif
